import { Arch } from "electron-builder-util";
import { Lazy } from "lazy-val";
import { Platform, Target } from "./core";
import { AfterPackContext } from "./metadata";
import { RequestedExecutionLevel, WinBuildOptions } from "./options/winOptions";
import { Packager } from "./packager";
import { PlatformPackager } from "./platformPackager";
import { FileCodeSigningInfo, SignOptions } from "./windowsCodeSign";
export declare class WinPackager extends PlatformPackager<WinBuildOptions> {
    readonly cscInfo: Lazy<FileCodeSigningInfo | null>;
    private _iconPath;
    readonly computedPublisherSubjectOnWindowsOnly: Lazy<string | null>;
    readonly computedPublisherName: Lazy<string[] | null>;
    readonly isForceCodeSigningVerification: boolean;
    constructor(info: Packager);
    readonly defaultTarget: Array<string>;
    protected doGetCscPassword(): string | undefined;
    createTargets(targets: Array<string>, mapper: (name: string, factory: (outDir: string) => Target) => void): void;
    readonly platform: Platform;
    getIconPath(): Promise<string | null>;
    private getValidIconPath();
    sign(file: string, logMessagePrefix?: string): Promise<void>;
    protected doSign(options: SignOptions): Promise<void>;
    signAndEditResources(file: string, arch: Arch, outDir: string, internalName?: string | null, requestedExecutionLevel?: RequestedExecutionLevel | null): Promise<void>;
    protected postInitApp(packContext: AfterPackContext): Promise<void>;
    protected signApp(packContext: AfterPackContext): Promise<any>;
}
